=== img/CMakeLists.txt ===
set(ICON_RC ${CMAKE_CURRENT_SOURCE_DIR}/icon.rc PARENT_SCOPE)
