=== third_party/msgpack/CMakeLists.txt ===
add_library(msgpack_c INTERFACE)
target_include_directories(msgpack_c INTERFACE
  ${CMAKE_CURRENT_SOURCE_DIR}/msgpack-c/include)
