=== debian/changelog ===
secure-socket-funneling (3.0.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:09:52 +0200

secure-socket-funneling (3.0.0-0kali4) kali-dev; urgency=medium

  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file
  * Disable build of linux package, keep only the windows binaries

 -- Raphaël Hertzog <raphael@offensive-security.com>  Thu, 09 Apr 2020 19:14:48 +0200

secure-socket-funneling (3.0.0-0kali3) kali-rolling; urgency=medium

  * Try to upload directly in kali-rolling

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 13 Jun 2019 10:37:03 +0200

secure-socket-funneling (3.0.0-0kali2) kali-dev; urgency=medium

  * Switch install location

 -- Ben Wilson <g0tmi1k@kali.org>  Mon, 10 Jun 2019 21:19:37 +0100

secure-socket-funneling (3.0.0-0kali1) kali-dev; urgency=medium

  * Import new upstream release

 -- Sophie Brun <sophie@freexian.com>  Mon, 27 Nov 2017 14:22:15 +0100

secure-socket-funneling (2.2.0-0kali2) kali-dev; urgency=medium

  * Add a patch to try to fix the build on arm

 -- Sophie Brun <sophie@freexian.com>  Tue, 23 May 2017 09:35:26 +0200

secure-socket-funneling (2.2.0-0kali1) kali-dev; urgency=medium

  * Initial release (Closes: 3505)

 -- Sophie Brun <sophie@freexian.com>  Thu, 11 May 2017 14:42:54 +0200
