=== debian/control ===
Source: secure-socket-funneling
Section: misc
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: debhelper (>= 10),
               unzip,
               cmake (>= 2.8.11),
#	       libboost1.62-all-dev,
               libkrb5-dev,
	       libssl1.0-dev,
               python
Standards-Version: 4.1.1
Homepage: https://github.com/securesocketfunneling/ssf

#Package: secure-socket-funneling
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Recommends: secure-socket-funneling-windows-binaries
#Description: Network tool and toolkit
# This package provides simple and efficient ways to forward data from multiple
# sockets (TCP or UDP) through a single secure TLS link to a remote computer.
# .
# SSF Features:
#  * Local and remote TCP port forwarding
#  * Local and remote UDP port forwarding
#  * Local and remote SOCKS server
#  * Local and remote shell through socket
#  * Native relay protocol
#  * TLS connection with strongest cipher-suites

Package: secure-socket-funneling-windows-binaries
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SSF - windows binaries
 This package provides simple and efficient ways to forward data from multiple
 sockets (TCP or UDP) through a single secure TLS link to a remote computer.
 .
 This package provides the 32 bits and 64 bits windows binaries of Secure Socket
 Funneling.
 .
 SSF Features:
  * Local and remote TCP port forwarding
  * Local and remote UDP port forwarding
  * Local and remote SOCKS server
  * Local and remote shell through socket
  * Native relay protocol
  * TLS connection with strongest cipher-suites
