=== debian/rules ===
#!/usr/bin/make -f

INSTALL_BIN_PATH=debian/ssf/usr/bin
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ -S none

override_dh_auto_configure:
	cp -r debian/cxxopts third_party/
	cp -r debian/googletest third_party/
	cp -r debian/http-parser third_party/http-parser
	cp -r debian/msgpack-c third_party/msgpack
	cp -r debian/spdlog third_party/spdlog
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DSSF_SECURITY:STRING="STANDARD" ../

override_dh_auto_test:
# drop the tests. can't get them build correctly
